#ifndef TRACE_HH
#define TRACE_HH


#include "pin.H"

extern "C" {
#include "xed-category-enum.h"
}

#include <iostream>

using std::ostream;

//////////////////////////////////////////
class Operation
{
 public:
  //  Operation(uint32_t in, uint32_t cy, ADDRINT addr, UINT32 op, uint32_t nd,
  //	    uint32_t d1, uint32_t d2, uint32_t d3, uint32_t d4);
  Operation();
  Operation(uint32_t in, uint32_t cy, ADDRINT addr, UINT32 op, uint32_t nrd, uint32_t *rd, uint32_t nmd, uint32_t *md,
	    xed_category_enum_t category, const char*tkey);
  uint32_t get_cycle();
  uint32_t get_address();

  void dump(ostream & os);
  void dumpkeys(ostream & os);
  //friend bool operator<(const Operation &op1, const Operation &op2);
 private:
  uint32_t inum;
  uint32_t cycle;
  ADDRINT address;
  UINT32 opcode;
  uint32_t nbrdep;
  uint32_t rdep[4];
  uint32_t nbmdep;
  uint32_t mdep[2];
  xed_category_enum_t xed_category;

  string trace_key;
//   uint32_t dep1;
//   uint32_t dep2;
//   uint32_t dep3;
//   uint32_t dep4;
};

class NumOp
{
public:
  NumOP();
  NumOP(uint32_t tid, uint32_t iid);
  uint32_t trace_id;
  uint32_t instance_id;
private:

};

class COperation
{
 public:
  //  Operation(uint32_t in, uint32_t cy, ADDRINT addr, UINT32 op, uint32_t nd,
  //	    uint32_t d1, uint32_t d2, uint32_t d3, uint32_t d4);
  COperation();
  COperation(uint32_t in, uint32_t cy, ADDRINT addr, UINT32 op, uint32_t nrd, uint32_t *rd, uint32_t nmd, uint32_t *md,
	    xed_category_enum_t category, const char*tkey);
  uint32_t get_cycle();
  uint32_t get_address();

  void dump(ostream & os);
  void dumpkeys(ostream & os);
  //friend bool operator<(const Operation &op1, const Operation &op2);
 private:
  //  uint32_t inum;
  uint32_t trace_id;
  uint32_t nb_instance;
  //  uint32_t start_cycle;
  //  uint32_t end_cycle;
  //  uint32_t cycle_step;
  vector<uint32_t> cycles;

  // Static information
  ADDRINT address;
  UINT32 opcode;

  // TODO : check if this assumption is realy TRUE :
  //     - dependencies do not need to record the all NumOp, 
  //       they only need to record the TID because there are
  //       no instance ambiguity : 
  //         "if total number of dependant instances is lower than 
  //          the current instance then current instance depends on
  //          last dependant instance.
  //          if current instance is lower than total dependent instances
  //          then current instance depends on same dependant instance number"
  uint32_t nbrdep;
  //  uint32_t rdep[4];
  NumOp rdep[4]
  uint32_t nbmdep;
  //  uint32_t mdep[2];
  NumOp mdep[2]
  xed_category_enum_t xed_category;

  string trace_key;
//   uint32_t dep1;
//   uint32_t dep2;
//   uint32_t dep3;
//   uint32_t dep4;
};



class CTrace
{
public:
  CTrace();
  void dump(ostream &os);
private:
  vector<COperation> trace;

};



//bool operator<(const Operation &op1, const Operation &op2);

/////////////////////////////////////////
// class Trace
// {
//  public:
//   Trace(uint32_t trace_length);
  
//  private:
//   //  uint32_t cycles[options.trace_length];
//   //  Operations operations[options.trace_length];

//   //   uint32_t cycles[];
//   //   Operations operations[];
//   vector<uint32_t> cycles;
//   vector<Operation> operations;

//   uint32_t nbcycles;
//   uint32_t nbinstr;

// };

#endif // TRACE_HH
