#ifndef GOOTRACE_HH
#define GOOTRACE_HH


#include "pin.H"
#include "ilpcommon.hh"

extern "C" {
#include "xed-category-enum.h"
}

#include <iostream>

using std::ostream;
using std::vector;

//////////////////////////////////////////
class GooOperation
{
 public:
  GooOperation();
  GooOperation(bool ctrl, uint32_t in, uint32_t cy, ADDRINT addr, UINT32 op, uint32_t nrd, uint32_t *rd, uint32_t nmd, uint32_t *md,
	       xed_category_enum_t category, const char*tkey, const char *rtn_name, uint32_t cid, uint32_t depth);
  bool control;
  uint32_t get_cycle();
  uint32_t get_address();
  uint32_t get_nbrdep();
  uint32_t get_nbmdep();
  uint32_t get_rdep(unsigned int i);
  uint32_t get_mdep(unsigned int i);

  void dump(ostream & os);
  void dumpkeys(ostream & os);
 private:
  uint32_t inum;
  uint32_t cycle;
  ADDRINT address;
  UINT32 opcode;
  uint32_t nbrdep;
  uint32_t rdep[8];
  uint32_t nbmdep;
  uint32_t mdep[8];
  xed_category_enum_t xed_category;

  string trace_key;

  string rtn_name;
  uint32_t cid;
  uint32_t depth;
};

/////////////////////////////////////////
class GooTrace
{
 public:
  GooTrace();
  void update_control(const uint32_t num, uint32_t *numinst_control, uint32_t *nbcycles_control);
  void update(const GooOperation &op, const uint32_t num);
  void dump(ostream &os, uint32_t nbinst);
  void resize(uint32_t size);
  
  GooOperation &operator [](uint32_t i);
 private:
  vector<GooOperation> operations;
};

#endif // GOOTRACE_HH
