#include <iostream>
//#include <iomanip>

#include "histogram.hh"
#include "config.hh"
#include <cstdlib>

using std::cerr;
using std::endl;
using std::hex;
using std::dec;

Histogram::Histogram()//: size(0)
{
  //this->resize(size);
}

void Histogram::update(uint32_t cycle, xed_category_enum_t category)
{
  if(cycle>histogram[category].capacity())
    {
      cerr << "DEBUG("<<hex<<this<<dec<<") Error: histogram length too short !!! (cycle: "<< cycle <<")" << endl;
      abort();
    }
  histogram[category][cycle]++;
  total[category]++;


#ifdef SHORT_HISTO
  uint32_t scycle = (cycle * shsize) / size;

  if (scycle>shisto.capacity())
    {
      cerr << "DEBUG("<<hex<<this<<dec<<") Error: shisto length too short !!! (scycle: "<< scycle <<")" << endl;
      abort();
    }    

  shisto[scycle]++;
#endif
}

void Histogram::dump(ostream &os, uint32_t nbcycles, ostream &colorfile)
{
  os << "Cycles";
  for(unsigned int j=0; j<XED_CATEGORY_LAST; j++)
    {
    if (total[j]>0)
    {
      os << "   \t" << xed_category_enum_t2str((xed_category_enum_t)j);
    }
    }
  os << endl;
  for(unsigned int i=0; i<= nbcycles; i++)
    {
      os << i;
      for(unsigned int j=0; j<XED_CATEGORY_LAST; j++)
	{
	if (total[j]>0)
	{
	  os << "   \t" << histogram[j][i];
	}
	}
      os << endl;
    }

  for(unsigned int j=0; j<XED_CATEGORY_LAST; j++)
    {
      if(total[j]) { colorfile << "1" << endl; }
      else { colorfile << "0" << endl; }
    }
}

void Histogram::sdump(ostream &os, uint32_t nbcycles)
{
#ifdef SHORT_HISTO
  os << "Cycles";
  os << "\t" << "Instructions";
  os << endl;
  for(unsigned int i=0; i<= shsize; i++)
    {
      os << i;
      os << "   \t" << shisto[i]*shsize/size;
      os << endl;
    }
#endif
}

void Histogram::resize(uint32_t new_size)
{
  for(unsigned int j=0; j<XED_CATEGORY_LAST; j++)
    {
      histogram[j].resize(new_size,0);
      total[j] = 0;
    }
#ifdef SHORT_HISTO
  size = new_size;
  shisto.resize(shsize+1,0);
#endif
}
