#ifndef HISTOGRAM_HH
#define HISTOGRAM_HH

#include <iostream>
#include <vector>
#include <stdint.h>

#include "config.hh"

extern "C" {
#include "xed-category-enum.h"
}


using std::ostream;
using std::vector;

class Histogram{
 public:
  Histogram();
  void update(uint32_t cycle, xed_category_enum_t category);
  void dump(ostream &os, uint32_t nbcycles, ostream &colorfile);
  void sdump(ostream &os, uint32_t nbcycles);
  void resize(uint32_t size);

 private:
  vector<uint32_t> histogram[XED_CATEGORY_LAST];
  uint32_t total[XED_CATEGORY_LAST];
#ifdef SHORT_HISTO
  vector<uint32_t> shisto;
  uint32_t size;
  static const uint32_t shsize=1024;
#endif
};


#endif // HISTOGRAM_HH
