#ifndef ILPHISTOGRAM_HH
#define ILPHISTOGRAM_HH

#include "pin.H"

#include "ilptool_interface.hh"
#include "ilpcommon.hh"

#include "utils/memory.hh"
#include "utils/memory.tcc"

#include "tools/histogram.hh"

extern "C" {
#include "xed-category-enum.h"
}

class IlpHistogram: public IlptoolInterface{
 protected:

  Memory<unsigned long> memory;

  uint32_t rat[REG_FILE_SIZE], nbread[REG_FILE_SIZE], nbwrite[REG_FILE_SIZE], npg;

 public:
  bool is_main;
 public:
  uint32_t nbcycles;
  uint32_t numinst;

public:
  Histogram histo;
  
 public:
  IlpHistogram(const char *nickname, uint32_t dh, uint32_t cid);
  ~IlpHistogram();
  
  // IlptoolInterface
  void instrument(INS ins, VOID *v);
  void analyse(Instruction &instr);
  void dump(ostream &os);
  void dumpxml(ostream &os, int depth);
  void stop();


  // VOID writetoreg(uint32_t c, UINT32 nw,
  // 		  UINT32 op,
  // 		  UINT32 wr0, UINT32 lenwr0,
  // 		  UINT32 wr1, UINT32 lenwr1,
  // 		  UINT32 wr2, UINT32 lenwr2,
  // 		  UINT32 wr3, UINT32 lenwr3);

  // uint32_t readfromreg(UINT32 nr,
  // 			    UINT32 rr0, UINT32 lenrr0,
  // 			    UINT32 rr1, UINT32 lenrr1,
  // 			    UINT32 rr2, UINT32 lenrr2,
  // 			    UINT32 rr3, UINT32 lenrr3);
  
  uint32_t readfrommem(ADDRINT amr, UINT32 rsize);  

  VOID writetomem(uint32_t cexe, ADDRINT amw, UINT32 wsize);

  bool stoped;
 }; // END of CLASS: IlpHistogram



// CLASS ROUTINE PROFILE IMPLEMENTS ROUTINE INTERFACE
class RoutineHistogram: public RoutineInterface{
 public:
  RoutineHistogram(const char *name, const char *image, ADDRINT addr, RTN rtn, IlptoolInterface *ilp);
  ~RoutineHistogram();
  
  // RoutineInterface
  virtual void start();
  virtual void stop();
  
//  protected:
//     string rtn_name;
//     string rtn_image;
//     ADDRINT rtn_address;
//     RTN rtn_rtn;
//     UINT64 rtn_rtnCount;
//     UINT64 rtn_depth_counter;
//     UINT64 rtn_start_depth;
//     bool is_rtn_starting_instrumentation;
// public:
//   //    vector<IlptoolInterface *> call_vector;
};


#endif
