#ifndef ILPPROFILE_HH
#define ILPPROFILE_HH

#include "pin.H"

#include "ilptool_interface.hh"
#include "ilpcommon.hh"

#include "utils/memory.hh"
#include "utils/memory.tcc"

extern "C" {
#include "xed-category-enum.h"
}

class IlpProfile: public IlptoolInterface{
 protected:

  Memory<unsigned long> memory;
//  Memory<unsigned long> memory_trace;

  uint32_t rat[REG_FILE_SIZE], nbread[REG_FILE_SIZE], nbwrite[REG_FILE_SIZE], npg;
  //  unsigned long rat_trace[REG_FILE_SIZE];//, nbread[REG_FILE_SIZE], nbwrite[REG_FILE_SIZE], npg;

 public:
  bool is_main;
  //  string name;
 public:
  uint32_t nbcycles;
  uint32_t numinst;
  
 public:
  IlpProfile(const char *nickname, uint32_t dh, uint32_t cid);
  ~IlpProfile();
  
  // IlptoolInterface
  void instrument(INS ins, VOID *v);
  void analyse(Instruction &instr);
  void dump(ostream &os);
  void dumpxml(ostream &os, int depth);
  void stop();



  // VOID writetoreg(uint32_t c, UINT32 nw,
  // 		  UINT32 op,
  // 		  UINT32 wr0, UINT32 lenwr0,
  // 		  UINT32 wr1, UINT32 lenwr1,
  // 		  UINT32 wr2, UINT32 lenwr2,
  // 		  UINT32 wr3, UINT32 lenwr3);

  // uint32_t readfromreg(UINT32 nr,
  // 			    UINT32 rr0, UINT32 lenrr0,
  // 			    UINT32 rr1, UINT32 lenrr1,
  // 			    UINT32 rr2, UINT32 lenrr2,
  // 			    UINT32 rr3, UINT32 lenrr3);
  
  uint32_t readfrommem(ADDRINT amr, UINT32 rsize);  

  VOID writetomem(uint32_t cexe, ADDRINT amw, UINT32 wsize);


  bool stoped;

 }; // END of CLASS: IlpProfile



// CLASS ROUTINE PROFILE IMPLEMENTS ROUTINE INTERFACE
class RoutineProfile: public RoutineInterface{
 public:
  RoutineProfile(const char *name, const char *image, ADDRINT addr, RTN rtn, IlptoolInterface *ilp);
  ~RoutineProfile();
  
  // RoutineInterface
  virtual void start();
  virtual void stop();  
};


#endif
