#ifndef ILPTRACE_HH
#define ILPTRACE_HH

#include "pin.H"

#include "ilptool_interface.hh"
#include "ilpcommon.hh"

#include "utils/memory.hh"
#include "utils/memory.tcc"

#include "tools/trace.hh"
#include "tools/gootrace.hh"

extern "C" {
#include "xed-category-enum.h"
}

class IlpTrace: public IlptoolInterface{
 protected:

  Memory<unsigned long> memory;
  Memory<unsigned long> memory_trace;

  uint32_t rat[REG_FILE_SIZE], nbread[REG_FILE_SIZE], nbwrite[REG_FILE_SIZE], npg;
  uint32_t rat_trace[REG_FILE_SIZE];

 public:
  bool is_main;
 public:
  uint32_t nbcycles;
  uint32_t numinst;
  uint32_t nbcycles_control;
  uint32_t numinst_control;

public:
  Trace trace;
  GooTrace gootrace;
  
 public:
  IlpTrace(const char *nickname, uint32_t dh, uint32_t cid);
  ~IlpTrace();
  
  // IlptoolInterface
  void instrument(INS ins, VOID *v);
  void analyse(Instruction &instr);
  void dump(ostream &os);
  void dumpxml(ostream &os, int depth);
  void stop();



  bool stoped;
 }; // END of CLASS: IlpTrace



// CLASS ROUTINE PROFILE IMPLEMENTS ROUTINE INTERFACE
class RoutineTrace: public RoutineInterface{
 public:
  RoutineTrace(const char *name, const char *image, ADDRINT addr, RTN rtn, IlptoolInterface *ilp);
  ~RoutineTrace();
  
  // RoutineInterface
  virtual void start();
  virtual void stop();
  
 protected:
    string rtn_name;
    string rtn_image;
    ADDRINT rtn_address;
    RTN rtn_rtn;
    UINT64 rtn_rtnCount;
    UINT64 rtn_depth_counter;
    UINT64 rtn_start_depth;
    bool is_rtn_starting_instrumentation;
public:
    vector<IlptoolInterface *> call_vector;
};


#endif
